extends KinematicBody2D

onready var world = get_parent()

export var speed = 15
export var wave_size = 0
export var wave_speed = 0

export var tumble = false
export var tumble_rate = 0.5
export var tumble_angle = -45
export var tumble_progress = 0

var wave_progress = 0
var was_destroyed = false


# Called when the node enters the scene tree for the first time.
func _ready():
	wave_progress = world.rng.randi() % 360


# Called every frame. 'delta' is the elapsed time since the previous frame.
func _physics_process(delta):
	if tumble:
		tumble_progress += delta
		$Appearance.rotation = deg2rad(round(tumble_progress / tumble_rate) * tumble_angle)
	wave_progress += wave_speed * delta
	var waveOffset = sin(deg2rad(wave_progress))
	var collision = move_and_collide(Vector2(-speed, waveOffset * wave_size), false)
	if collision != null and collision.collider.is_in_group("player"):
		world.DecreaseLivePoints() # decrease LP
		was_destroyed = true
		queue_free() # destroy obstacle
	
	if collision != null and collision.collider.is_in_group("despawn"):
		queue_free()


# this function allows to increase the score as soon as the object leaves the screen
func _on_VisibilityNotifier2D_screen_exited():
	was_destroyed = false # reset value
	queue_free()
