extends RigidBody2D

export var jump_speed = 2300
export var player_speed = 500

onready var animation_boy = get_node("Boy")
onready var animation_girl = get_node("Girl")
onready var tween = get_node("Tween")

onready var boy_girl_right_collision_detection = get_node("BoyGirlRightCollissionDetection")
onready var boy_left_collision_detection = get_node("BoyLeftCollisionDetection")
onready var girl_left_collision_detection = get_node("GirlLeftCollisionDetection")

onready var touch_buttons = get_node("MobileMovements")

var y_position_on_ground = 938
var collisions

# Called every frame. 'delta' is the elapsed time since the previous frame.
func _physics_process(delta):
	
	if get_tree().current_scene.name == "World":
		touch_buttons.get_child(0).show()
		touch_buttons.get_child(1).show()
		touch_buttons.get_child(2).show()
		touch_buttons.get_child(3).show()
	
	if get_position().y >= y_position_on_ground:
		animation_boy.play("Run")
		animation_girl.play("Run")
	else:
		animation_boy.play("Jump")
		animation_girl.play("Jump")
	
	# when player tries to run out of the screen
	if get_position().x < 100 or get_position().x > 1800:
		linear_velocity.x = 0 #Vector2.ZERO
	
	# when the player wants to jump
	if Input.is_action_just_pressed("jump"):
		collisions = get_colliding_bodies()
		if collisions.size() != 0:
			apply_impulse(Vector2(), Vector2(0,-jump_speed))
	
	# when the player wants to pause the game
	if Input.is_action_just_pressed("pause"):
		var pause = load("res://Scenes/PauseMenu.tscn").instance()
		pause.rect_position = get_viewport_rect().size / 2
		get_parent().add_child(pause)
		get_tree().paused = true
	
	# when the player wants to move left
	if Input.is_action_pressed("ui_left"):
		if get_position().x > 100:
			set_axis_velocity(Vector2(-player_speed, 0))
			animation_boy.set_flip_h(true)
			animation_girl.set_flip_h(true)
			
			boy_girl_right_collision_detection.disabled = true
			if animation_boy.visible == true:
				boy_left_collision_detection.disabled = false
			
			if animation_girl.visible == true:
				girl_left_collision_detection.disabled = false
	
	# when the player wants to move right
	if Input.is_action_pressed("ui_right"):
		if get_position().x < 1800:
			set_axis_velocity(Vector2(player_speed, 0))
			animation_boy.set_flip_h(false)
			animation_girl.set_flip_h(false)
			
			boy_girl_right_collision_detection.disabled = false
			
			if animation_boy.visible == true:
				boy_left_collision_detection.disabled = true
			
			if animation_girl.visible == true:
				girl_left_collision_detection.disabled = true

